//
//  FNALITradeZipArchiver.m
//  新版嗨如意
//
//  Created by FNUser on 2020/10/26.
//  Copyright © 2020 方诺科技. All rights reserved.
//

#import "FNALITradeZipArchiver.h"
#import <ZipArchive/ZipArchive.h>

@interface FNALITradeZipArchiverOp()

@property (nonatomic, strong) ZipArchive *innerArchiver;

@end

@implementation FNALITradeZipArchiverOp
- (ZipArchive *)innerArchiver {
    if (!_innerArchiver) {
        _innerArchiver = [ZipArchive new];
    }
    return _innerArchiver;
}
- (BOOL)UnzipOpenFile:(NSString *)zipFile{
    return [self.innerArchiver UnzipOpenFile:zipFile];
}
- (BOOL)UnzipCloseFile{
    return [self.innerArchiver UnzipCloseFile];
}
- (BOOL)UnzipFileTo:(NSString *)path overWrite:(BOOL)overwrite{
    return [self.innerArchiver UnzipFileTo:path overWrite:overwrite];
}

@end

@implementation FNALITradeZipArchiver

- (id<TRVZipOperationProtocol>)zipArchiverInstance{
    return [FNALITradeZipArchiverOp new];
}

@end
